import { AfterViewInit, ElementRef, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "primeng/api";
declare type BadgeDirectiveIconPosition = 'left' | 'right' | 'top' | 'bottom';
declare type BadgeSize = 'large' | 'xlarge';
export declare class BadgeDirective implements AfterViewInit, OnDestroy {
    private document;
    el: ElementRef;
    private renderer;
    iconPos: BadgeDirectiveIconPosition;
    disabled: boolean;
    severity: string;
    badgeStyle: {
        [klass: string]: any;
    } | null | undefined;
    badgeStyleClass: string;
    set size(value: 'large' | 'xlarge');
    get size(): 'large' | 'xlarge';
    _size: BadgeSize;
    initialized: boolean;
    value: string | number;
    private id;
    badgeEl: HTMLElement;
    private get activeElement();
    private get canUpdateBadge();
    constructor(document: Document, el: ElementRef, renderer: Renderer2);
    ngOnChanges({ value, size, severity, disabled, badgeStyle, badgeStyleClass }: SimpleChanges): void;
    private renderBadgeContent;
    private setSeverity;
    ngAfterViewInit(): void;
    private setValue;
    private applyStyles;
    private setSizeClasses;
    private toggleDisableState;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<BadgeDirective, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<BadgeDirective, "[pBadge]", never, { "iconPos": "iconPos"; "disabled": "badgeDisabled"; "severity": "severity"; "badgeStyle": "badgeStyle"; "badgeStyleClass": "badgeStyleClass"; "size": "size"; "value": "value"; }, {}, never, never, false, never>;
}
export declare class Badge {
    styleClass: string;
    style: any;
    size: BadgeSize;
    severity: string;
    value: string;
    badgeDisabled: boolean;
    containerClass(): {
        'p-badge p-component': boolean;
        'p-badge-no-gutter': boolean;
        'p-badge-lg': boolean;
        'p-badge-xl': boolean;
        'p-badge-info': boolean;
        'p-badge-success': boolean;
        'p-badge-warning': boolean;
        'p-badge-danger': boolean;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<Badge, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<Badge, "p-badge", never, { "styleClass": "styleClass"; "style": "style"; "size": "size"; "severity": "severity"; "value": "value"; "badgeDisabled": "badgeDisabled"; }, {}, never, never, false, never>;
}
export declare class BadgeModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<BadgeModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<BadgeModule, [typeof Badge, typeof BadgeDirective], [typeof i1.CommonModule], [typeof Badge, typeof BadgeDirective, typeof i2.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<BadgeModule>;
}
export {};
