import { AnimationEvent } from '@angular/animations';
import { AfterContentInit, AfterViewInit, ChangeDetectorRef, ElementRef, OnDestroy, QueryList, Renderer2, TemplateRef } from '@angular/core';
import { Confirmation, ConfirmationService, OverlayService, PrimeNGConfig } from 'primeng/api';
import { ConnectedOverlayScrollHandler } from 'primeng/dom';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "primeng/button";
import * as i3 from "primeng/api";
export declare class ConfirmPopup implements AfterContentInit, OnDestroy, AfterViewInit {
    el: ElementRef;
    private confirmationService;
    renderer: Renderer2;
    private cd;
    config: PrimeNGConfig;
    overlayService: OverlayService;
    private document;
    key: string;
    defaultFocus: string;
    showTransitionOptions: string;
    hideTransitionOptions: string;
    autoZIndex: boolean;
    baseZIndex: number;
    style: any;
    styleClass: string;
    templates: QueryList<any>;
    container: HTMLDivElement;
    subscription: Subscription;
    confirmation: Confirmation;
    acceptIconTemplate: TemplateRef<any>;
    rejectIconTemplate: TemplateRef<any>;
    _visible: boolean;
    documentClickListener: VoidFunction | null;
    documentResizeListener: VoidFunction | null;
    scrollHandler: ConnectedOverlayScrollHandler | null;
    get visible(): any;
    set visible(value: any);
    private window;
    constructor(el: ElementRef, confirmationService: ConfirmationService, renderer: Renderer2, cd: ChangeDetectorRef, config: PrimeNGConfig, overlayService: OverlayService, document: Document);
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationEnd(event: AnimationEvent): void;
    getElementToFocus(): any;
    align(): void;
    hide(): void;
    accept(): void;
    reject(): void;
    onOverlayClick(event: any): void;
    bindListeners(): void;
    unbindListeners(): void;
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    onWindowResize(): void;
    bindDocumentResizeListener(): void;
    unbindDocumentResizeListener(): void;
    bindScrollListener(): void;
    unbindScrollListener(): void;
    unsubscribeConfirmationSubscriptions(): void;
    onContainerDestroy(): void;
    restoreAppend(): void;
    get acceptButtonLabel(): string;
    get rejectButtonLabel(): string;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfirmPopup, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ConfirmPopup, "p-confirmPopup", never, { "key": "key"; "defaultFocus": "defaultFocus"; "showTransitionOptions": "showTransitionOptions"; "hideTransitionOptions": "hideTransitionOptions"; "autoZIndex": "autoZIndex"; "baseZIndex": "baseZIndex"; "style": "style"; "styleClass": "styleClass"; "visible": "visible"; }, {}, ["templates"], never, false, never>;
}
export declare class ConfirmPopupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfirmPopupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ConfirmPopupModule, [typeof ConfirmPopup], [typeof i1.CommonModule, typeof i2.ButtonModule, typeof i3.SharedModule], [typeof ConfirmPopup, typeof i3.SharedModule]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ConfirmPopupModule>;
}
